

BEGIN {

        State="";
        NprLine=0;
        LastPrLine=0;
        TablePlase=0;

        Debug=0;

        Inf="$\\infty$";
        Procherk="$-$";
        LastNom=0;
        ErrMes = "";

        mkJ=0; 
        mkZ=1; #!!
        mkR=0;
        mkOldR=0;
        mkF=0;
        mkP=0;
        cpP=0;

        MainInp="mainr.inp"
        print("")>MainInp;  #!!!!!!

        ftpS="ftp-s.tmp";
        ftpSnoLog="ftp-snl.tmp";
        ftpBat="ToFtp.bat";

	Compress="compress.tmp";
	Syncpic="syncpic.tmp";
	Copypic="copypic.tmp";


       	Htmlmainr="htm.tmp";
	Bat="tmp.bat";

	Ext="jpg"; DPI=120;
	#Ext="png"; DPI=600;

	PorNomi=0;

	NcOpt="";
	PicDir="";
	PicPref="";


}

function printHR(A){print(A)>>Htmlmainr}
function printR(A){print(A)>>MainInp}
function printF(A){print(A)>>ftpBat}
function printFF(A){print("echo "A">>%ftps%")>>ftpBat}

function Dbg(A){ if (Debug) print("%",A) }

function Int(x){return int(x*100)/100}


($1 == "")  {next;} 


/^[ \t]*\#<[uU]rl.*/ {State="Url"; next;} 
/^[ \t]*\#<[pP]ic.*/ {State="Pic"; next;} 
/^[ \t]*\#<[rR]ez.*/ {State="Rez"; next;} 
/^[ \t]*\#<[Oo]ld[rR]ez.*/ {State="OldRez"; next;} 

/^[ \t]*\#<.*/    {State="Comment"; next;} 

/^[ \t]*\#>.*/    {State=""; next;} 

/^[ \t]*\#.*/  {    next;}

(State == "Comment") {Dbg($0); next;}

##    ?

(State == "" && $1 ~ /^[Bb]ar[Cc]ode$/) {next;}
(State == "" && $1 ~ /^[Pp]rint/) {next;}
(State == "" && $1 == "Date") {next;}
(State == "" && $1 == "GroupName") {next;}
(State == "" && $1 ~ /[Oo][Tt][Vv]/) {next;}


(State == "" && $1 ~ /^[Ff][Tt][Pp]$/) {

	mkF=1;
	Passw="";

	
	$1="";
	tmp=$0;

	sub(/^[ \t]*/,"",tmp);	sub(/[ \t]*$/,"",tmp);	
	gsub(/\\/,"/",tmp);
	
	if (tmp ~ /[fF][tT][pP]:\/\// )  sub(/^....../,"",tmp) ;

	UnameAndP=tmp; sub(/@.*$/,"",UnameAndP);
	
	if (UnameAndP ~ /:/) {
		Uname=UnameAndP; sub(/:.*$/,"",Uname);
		Passw=UnameAndP; sub(/^.*:/,"",Passw);
	}
	else { 
		Uname=UnameAndP;
		Passw="";
	}       
	
	Dbg("UnameAndP "UnameAndP);
	Dbg("Uname "Uname);
	Dbg("Passw "Passw);

	FtpSite=tmp ; sub(/^.*@/,"",FtpSite); sub(/\/.*$/,"",FtpSite)
	Dbg("FtpSite "FtpSite);

	FtpDir=tmp; 
	if (FtpDir ~ /\/./)  sub(/^[^\/]*\//,"",FtpDir) 
	else FtpDir="/";
	Dbg("FtpDir "FtpDir);

	next;
}


(State == "" && $1 ~ /^[Jj][Oo][Bb]$/) {
	
	JobMod=1;

	mkZ=0;
	
	$1="";
	if ( $0 ~ /[Jj]/ ) {mkJ=1; Ext="jpg"; DPI=120;}
	if ( $0 ~ /[Pp]/ ) {mkJ=1; Ext="png"; DPI=120;}
	if ( $0 ~ /[Rr]/ ) {mkR=1;  }
	if ( $0 ~ /[Zz]/ ) {mkZ=1;  }
	
	next;
}




($1 ~ /^[Pp]ic[Dd]ir$/) {  

	mkP=1;	

	Recognize=1;

	$1="";	
	sub(/^[ \t]*/,""); sub(/[ \t]*$/,"");
	PicDir="\""$0"\"";
	next;

}


($1 ~ /^[Nn]convert[Oo]pt/) {


	$1="";	
	sub(/^[ \t]*/,""); sub(/[ \t]*$/,"");
	NcOpt="\""$0"\"";
	next;

}

($1 ~ /^[Pp]ic[Pp]ref/) {

	$1="";	
	sub(/^[ \t]*/,""); sub(/[ \t]*$/,"");
	PicPref=$0;
	next;

}





#--------------------------------------------------------
(State == "" ) {  
	KolVoZd[$1]=NF-1; 
	
	PorNomi++;
	PorNom[PorNomi]=$1;

	next; 
}
#-------------------------------------------------------



(State == "Url") {

	Name=$1;  $1="";

	sub(/^[ \t]*/,""); sub(/[ \t]*$/,"");

	#########!!!!!!!!!!!!
	gsub(/%/,"\\%");

	if ($0 != "") {Url[Name]=$0};
	
	next;
}




(State == "Pic" && $1 ~ /^[Pp]ic[Tt]o[Dd]ir$/) {  

	cpP=1;	

	$1="";	
	sub(/^[ \t]*/,""); sub(/[ \t]*$/,"");
	PicToDir="\""$0"\"";
	next;

}




(State == "Pic") {

        Name=$1;
        
        $1="";
	sub(/^[ \t]*/,""); sub(/[ \t]*$/,"");

	split($0,Arr);


	for ( i=1 ; i in Arr ; i++ ) {
		
		
		if (Arr[i] ~ /^[01-9]+$/) {

			PicName = Preff Arr[i];
			
		}
		else{
			if ((i+1) in Arr) if ( Arr[i+1] ~ /^[01-9]+$/) {
				Preff = Arr[i];
				PicName="";			
			}
			else{
				PicName = Arr[i];
			}

		}

		if (PicName != ""){
			
			sub(/\.[jJ][pP][eE]*[gG]/,"",PicName);


			CpPicList[Name] = CpPicList[Name] " " PicName;

			PicList[Name] = PicList[Name] "<br><a href=" PicName ".jpg>"PicName"</a>";

			AllPics[PicName]; 
		}

	
	}


	next;

}





(State == "Rez" && $1 ~/^[Em]rr[Mm]es/) { 
	
	
	if ($2 != "" ) {
		$1= "";
		ErrMes = "{\\bf\\Large "$0"} "	
	} 
	
	next; 

}

(State == "Rez" && ($1 ~ /^[Pp]rint$/)  ) { 
	NprLine++; 
	$1="";
	sub(/^[ \t]*/,"")
	PrPrint[NprLine]=$0;
	LastPrLine=NprLine;
	next;
}

(State == "Rez" && $1 == "Date") {
	
	Dbg($0);	

	TablePlase=LastPrLine;  #  print

	PrDate= "  "	

	for (i=2 ; i<=NF ; i++){

		PrDate= PrDate "& " $(i);
		#Date[i-1]=$(i);
	}

	PrDate= PrDate "& (*) & IQ & (**) \\\\ "
	
	Dbg(PrDate);
	
	KolVoKontr=NF-1;
	next;
}


(State == "OldRez" && $1 == "Date") {next; }
(State == "OldRez" && $1 ~ /GroupName/) {next; }
(State == "OldRez" && $1 ~/^[Em]rr[Mm]es/) {next; }


(State == "OldRez") {
	
	mkOldR=1;

	Name=$1;

        for(i=3 ; i<=NF ; i++){

       		if ($(i)~/[0-9]+/ && $(i) >= 0){
        		OldPrisutstv[Name]++;
        		OldResheno[Name]=OldResheno[Name]+$(i);
	       	}


        }
                
}



(State == "Rez") {


	Name=$1; 
       	
       	Norma[Name]=$2;
	Prisutstv[Name]=0;
	Resheno[Name]=0;



       	LastNom++; SortName[LastNom]=Name;

       	Pnom[Name]=LastNom;

       	if ( NF-2 > KolVoKontr) { Error[Name]=ErrMes }   #####################################

	PrName[Name]=Name; gsub(/_/," ",PrName[Name]);
        
	Rez[Name]= "" ;

     	for(i=3 ; i<=KolVoKontr+2 ; i++){

		if ($(i)~/[0-9]+/ && $(i) >= 0){
			Prisutstv[Name]++;
			Resheno[Name]=Resheno[Name]+$(i);
		}
		
		if ($(i)<0) {
			if (Resheno[Name] < Norma[Name]) Dobbb=Procherk
			else Dobbb=""
		}
		else if($(i) == "x" || $(i) == "X" || $(i) == "" || $(i) == "" ) {
			Dobbb=Procherk;
			Otchislen[Name]=1;		
		}
		else Dobbb=$(i)


		Rez[Name] = Rez[Name] " & " Dobbb;
	}

	#----
	#---
}



function Less(i,j){

	
	if ( Ostalos[SortName[i]] == Inf ) {
		if (Ostalos[SortName[j]] != Inf ) return 1 
		else return 0; 
	}


	if ( Ostalos[SortName[i]] == Procherk) {
		if (Ostalos[SortName[j]] != Procherk &&  Ostalos[SortName[j]] != Inf) return 1; 
		if (Ostalos[SortName[j]] == Inf) return 0; 
	}


	if (Ostalos[SortName[j]] == Procherk ||  Ostalos[SortName[j]] == Inf) return 0; 


	if ( Ostalos[SortName[i]] > Ostalos[SortName[j]] )  return 1 ;
	if ( Ostalos[SortName[i]] < Ostalos[SortName[j]] )  return 0 ;



	if ( Ostalos[SortName[i]] == Ostalos[SortName[j]]) {
		 if (Skorost[SortName[i]] < Skorost[SortName[j]])  return 1 ;
		 if (Skorost[SortName[i]] > Skorost[SortName[j]])  return 0 ;
	}


	return 0;

}


function SortArr(Arr,   i,j,tmp){
	for (i=2 ; i in Arr ; i++)  
		for (j=i ; j>=2 ; j--){
			if ( Less(j,j-1) ){
				tmp=Arr[j];
				Arr[j]=Arr[j-1];
				Arr[j-1]=tmp;
                        }
                }                            
}



END{

        Fnm=FILENAME;
        sub(/\..*$/,"",Fnm); sub(/^.*\\/,"",Fnm); 
        Dbg(FILENAME " "Fnm);



	if (mkJ) {print("!") >"j.tmp"}
	if (mkR) {print("!") >"r.tmp"}
	if (mkZ) {print("!") >"z.tmp"}


        if(mkR) {


                        for (Name in Rez) {
                          #--

                        	Skorost[Name]=Procherk;
                        	Ostalos[Name]=Procherk;

                        	if ( (0+Prisutstv[Name]+OldPrisutstv[Name] )!= 0){

                        	       	Ostalos[Name]=Inf;

                        		Skorost[Name]=(Resheno[Name]+OldResheno[Name] )/(Prisutstv[Name]+OldPrisutstv[Name]);
                                                
                        		if(Skorost[Name] > 0) {
                        			Ostalos[Name]=int(((Norma[Name]-Resheno[Name])/Skorost[Name])+0.9999);
                                                Skorost[Name]=Int(Skorost[Name]);
                        		}
                        	}	

                        	Rez[Name] = Rez[Name] " & "  (Norma[Name]-Resheno[Name]) " & " Skorost[Name] " & " Ostalos[Name] " \\\\"; 
                        	
                        	if(mkOldR) {Rez[Name]= " & " OldResheno[Name]+0 "/" OldPrisutstv[Name]+0 " "  Rez[Name]}


                        	if ( (Name in KolVoZd)  &&   KolVoZd[Name] != (Norma[Name]-Resheno[Name]) ) { Error[Name]=ErrMes }; ###########

                        	#aNorma[Name]=    Norma[Name]  ;
                        	#aResheno[Name]=  Resheno[Name];
                        	#aSkorost[Name]=  Skorost[Name];
                        	#aOstalos[Name]=  Ostalos[Name];



                          #--
                	}





        	for (i=1 ; i<=TablePlase ; i++ ) printR(PrPrint[i]);
        	

        	##############!!!


		for (i in PrName) {

                	if (i in Otchislen) PrName[i]="\\sout{"PrName[i]"}";
                
                	if (i in Url) PrName[i]="\\href{"Url[i]"}{"PrName[i]"}";
                	##else if (i in PicList) {
                	else if (mkP) {
                		
                		#   html
                		#tmp=Fnm "r" Pnom[i];
                                #print(htmlBEGIN "\n" PrName[i] PicList[i] "\n" htmlEND)>Adler(i)".htmp";			

                		#PrName[i]="\\href{"tmp".html}{"PrName[i]"}";
                		PrName[i]="\\href{"Adler(i) ".html}{"PrName[i]"}";

                	}


        	}


        	printR("\\par\\noindent");

        	S="\\begin{tabular}{";
        	if (mkOldR) {S=S"lc"}
        	else {S=S"l"}

        	for(i=1 ; i<=KolVoKontr ; i++) S=S"@{\\,}c";
        	#S=S "|c|c@{\\,}c}";
        	S=S "|c|c@{\\,}|c}";

        	printR(S);

        	if (mkOldR) {printR("& x/y" PrDate)}
        	else        {printR(PrDate)}

        	printR("\\hline")

        	SortArr(SortName);

        	Delim=1;
        	for (i=1 ; i in SortName ; i++ ) { 

        		#if (aOstalos[SortName[i]] == 0 && Delim) {
        		#	print("\\hline");
        		#	Delim=0;			
        		#} 

        		printR(Error[SortName[i]] PrName[SortName[i]] Rez[SortName[i]]) 
        	}

        	#printR("\\hline")
        	printR("\\end{tabular}");

        	printR("\\par");

        	for (i=TablePlase+1 ; i<=LastPrLine ; i++ ) printR(PrPrint[i]);
        }

        if ((mkF && mkJ) || (mkF && mkR)) {
        
	        print("@echo off\nchcp 866\nset ftps=ftp-snl.tmp\nif %1- == login- set ftps=ftp-s.tmp\nif exist %ftps% del %ftps%")>ftpBat;
                printFF("open "FtpSite)
                printFF(Uname)
                
                if (Passw !="") {
                	printFF(Passw)
                }
                else {
                	printF("setlocal")
                	printF("set /P pass=pass?:")
                	printFF("%pass%")
                	printF("endlocal")
                }

                printFF("quote pasv")
                printFF("binary")

                printFF("cd "FtpDir)

                printF("if %1- == login- goto end")


                printF("for %%a in (*.html *.jpg  *.jpeg *.png) do echo put %%a>>%ftps%")
                printF("::for %%a in (*.pdf) do echo put %%a>>%ftps%")

                printFF("quit")
                printF("ftp -s:%ftps%")
                printF("del %ftps%");
                printF("pause");
                printF(":end");

        }

        if (mkJ) {

        	# # # #if (Ext == "png") {print("dvips -x200 -E -i1 -o tmpjpeg.ps ru-jpeg.dvi") >Bat }
        	if (Ext == "png") {print("dvips -V -x1000 -E -i1 -o tmpjpeg.ps ru-jpeg.dvi") >Bat }
		else {print("dvips -V -x1000 -E -i1 -o tmpjpeg.ps ru-jpeg.dvi") >Bat  }     

        	printHR(htmlBEGIN)

        	for ( i=1 ; i in PorNom ; i++) {
        		tmp=PorNom[i];

			if (length(""i) < 3) tmpN="0" i;
			if (length(""i) < 2) tmpN="00" i;

			if(KolVoZd[tmp] >0) {
				gsub(/_/," ",tmp);
	        		printHR("<a href="Fnm tmpN"."Ext">" tmp "</a><br>")

        			print("call eps2jpeg " "tmpjpeg."tmpN " " Fnm tmpN"."Ext"" " " Ext " " DPI) >>Bat
        		}
        	}

	       	printHR(strftime() htmlEND ); 

        
        }


	if (mkP && mkR) {

        	print("call ..\\..\\..\\cmprs.bat "PicDir " \"" PicPref "\" " NcOpt ) > Compress;        

        	#for (i in AllPics) print(i)>>"pl.tmp";

                print("")                                   > "pl.tmp"
        	for (i in CpPicList) print(i,CpPicList[i]) >> "pl.tmp";

                print("")                                   > "nopl.tmp"
        	for (i in PrName) 
        		if ( !(i in Url) && !(i in CpPicList) ) 
        			{
        				print(i) >> "nopl.tmp";
        			}
		if (Recognize) print("call ..\\..\\..\\recog.bat "PicDir) >"recognize.tmp";

		print("call ..\\..\\..\\mkh.bat "PicDir) >"makehtml.tmp";



	}

        if (mkP && mkR && mkF) {

		if (cpP) print("call ..\\..\\..\\spic.bat "PicDir" "PicToDir) > Syncpic;        
		else     print("call ..\\..\\..\\spic.bat "PicDir  ) > Syncpic;        
	        
        }

        if (mkP && mkR && cpP) {

		print("call ..\\..\\..\\cpic.bat "PicDir " "PicToDir ) > Copypic;        
        
        }




}


